HubstaffDeveloper Portal

Activities

Get tracked keyboard, mouse, and overall activity levels

List organization activities

GET/v2/organizations/{organization_id}/activities

Returns a collection of activities (10-minute time blocks) for the given organization.

Results can be filtered by user, task, project, and time range (time_slot[start], time_slot[stop]).

For aggregated daily data, use the daily_activities endpoint instead.

Note: Data may be delayed up to 20 minutes. Note: Date range limit is 7 days. Earliest date is 6 months ago.

Parameters

NameInTypeDescription
organization_idrequired
pathinteger (int32)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
time_slot[start]required
querystring (date-time)
Start time (ISO 8601)
time_slot[stop]required
querystring (date-time)
Stop time (ISO 8601, Exclusive)
user_ids
queryarray integer[]
List of user IDs
task_ids
queryarray integer[]
List of task IDs
global_todo_ids
queryarray integer[]
List of global todo IDs
project_ids
queryarray integer[]
List of project IDs
include
queryarray string[]
Specify related data to side load.
Possible valuesusersprojectstasks
time_zone
querystring
The time zone name for the activity

Responses

200A list of activities
object
  • activitiesarray
    array<object>
    items
    object

    Activity model

    • idinteger required

      Activity ID

    • datestring required

      Organization date

    • created_atstring required

      When the record was created

    • updated_atstring required

      When the record was last updated

    • time_slotstring required

      Time slot

    • starts_atstring required

      Date and time tracking was started within time slot

    • user_idinteger required

      User ID

    • project_idinteger required

      Project ID

    • task_idinteger required

      Task ID

    • keyboardinteger required

      The amount of time the keyboard was active within the time worked in seconds

    • mouseinteger required

      The amount of time the mouse was active within the time worked in seconds

    • overallinteger required

      The amount of time the keyboard or mouse was active within the time worked in seconds

    • trackedinteger required

      Total time worked in seconds

    • input_trackedinteger required

      Total time worked in seconds with input tracking enabled (keyboard, mouse)

    • tracks_inputboolean required

      Whether the source can and had input tracking enabled activities (keyboard, mouse)

    • location_typestring required

      Remote vs in-office status: unknown, remote, or on_site

    • billableboolean required

      Whether the time is billable

    • paidboolean required

      Whether the time has been marked paid

    • client_invoicedboolean required

      Whether the time has been invoiced to a client

    • team_invoicedboolean required

      Whether the time has been invoiced for a team member

    • immutableboolean required

      Whether the time is locked

    • timesheet_idinteger

      The timesheet for this activity

    • timesheet_lockedboolean

      Whether the timesheet is locking this activity

    • time_typestring required

      The type of activity this is

    • clientstring required

      Which client the activity originated from

Example response
json
{
  "activities": [
    {
      "id": 0,
      "date": "2024-01-15",
      "created_at": "2024-01-15T10:30:00Z",
      "updated_at": "2024-01-15T10:30:00Z",
      "time_slot": "2024-01-15T10:30:00Z",
      "starts_at": "2024-01-15T10:30:00Z",
      "user_id": 0,
      "project_id": 0,
      "task_id": 0,
      "keyboard": 0,
      "mouse": 0,
      "overall": 0,
      "tracked": 0,
      "input_tracked": 0,
      "tracks_input": false,
      "location_type": "string",
      "billable": false,
      "paid": false,
      "client_invoiced": false,
      "team_invoiced": false,
      "immutable": false,
      "timesheet_id": 0,
      "timesheet_locked": false,
      "time_type": "string",
      "client": "string"
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}

List organization activities updates

GET/v2/organizations/{organization_id}/activities/updates

Returns activities that were updated within the given time range. Useful for syncing changes.

Results can be filtered by updated[start]/[stop], user_ids[], task_ids[], global_todo_ids[], and project_ids[].

Note: Data may be delayed up to 20 minutes. Date range limit is 7 days. Earliest date is 45 days ago.

Parameters

NameInTypeDescription
organization_idrequired
pathinteger (int32)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
updated[start]required
querystring (date-time)
Start time (ISO 8601)
updated[stop]required
querystring (date-time)
Stop time (ISO 8601)
user_ids
queryarray integer[]
List of user IDs
task_ids
queryarray integer[]
List of task IDs
global_todo_ids
queryarray integer[]
List of global todo IDs
project_ids
queryarray integer[]
List of project IDs
include
queryarray string[]
Specify related data to side load.
Possible valuesusersprojectstasks

Responses

200A list of activities
object
  • activitiesarray
    array<object>
    items
    object

    Activity model

    • idinteger required

      Activity ID

    • datestring required

      Organization date

    • created_atstring required

      When the record was created

    • updated_atstring required

      When the record was last updated

    • time_slotstring required

      Time slot

    • starts_atstring required

      Date and time tracking was started within time slot

    • user_idinteger required

      User ID

    • project_idinteger required

      Project ID

    • task_idinteger required

      Task ID

    • keyboardinteger required

      The amount of time the keyboard was active within the time worked in seconds

    • mouseinteger required

      The amount of time the mouse was active within the time worked in seconds

    • overallinteger required

      The amount of time the keyboard or mouse was active within the time worked in seconds

    • trackedinteger required

      Total time worked in seconds

    • input_trackedinteger required

      Total time worked in seconds with input tracking enabled (keyboard, mouse)

    • tracks_inputboolean required

      Whether the source can and had input tracking enabled activities (keyboard, mouse)

    • location_typestring required

      Remote vs in-office status: unknown, remote, or on_site

    • billableboolean required

      Whether the time is billable

    • paidboolean required

      Whether the time has been marked paid

    • client_invoicedboolean required

      Whether the time has been invoiced to a client

    • team_invoicedboolean required

      Whether the time has been invoiced for a team member

    • immutableboolean required

      Whether the time is locked

    • timesheet_idinteger

      The timesheet for this activity

    • timesheet_lockedboolean

      Whether the timesheet is locking this activity

    • time_typestring required

      The type of activity this is

    • clientstring required

      Which client the activity originated from

Example response
json
{
  "activities": [
    {
      "id": 0,
      "date": "2024-01-15",
      "created_at": "2024-01-15T10:30:00Z",
      "updated_at": "2024-01-15T10:30:00Z",
      "time_slot": "2024-01-15T10:30:00Z",
      "starts_at": "2024-01-15T10:30:00Z",
      "user_id": 0,
      "project_id": 0,
      "task_id": 0,
      "keyboard": 0,
      "mouse": 0,
      "overall": 0,
      "tracked": 0,
      "input_tracked": 0,
      "tracks_input": false,
      "location_type": "string",
      "billable": false,
      "paid": false,
      "client_invoiced": false,
      "team_invoiced": false,
      "immutable": false,
      "timesheet_id": 0,
      "timesheet_locked": false,
      "time_type": "string",
      "client": "string"
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}

List organization daily activities

GET/v2/organizations/{organization_id}/activities/daily

Returns daily aggregated time tracking data for the given organization.

Results can be filtered by user_ids[], task_ids[], project_ids[], and date[start]/[stop]. Data is aggregated by organization timezone date.

Note: Date range limit is 31 days. Earliest date is 3 years ago.

Parameters

NameInTypeDescription
organization_idrequired
pathinteger (int32)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
date[start]required
querystring (date)
Start date (ISO 8601)
date[stop]required
querystring (date)
Stop date (ISO 8601, Inclusive)
user_ids
queryarray integer[]
List of user IDs
task_ids
queryarray integer[]
List of task IDs
project_ids
queryarray integer[]
List of project IDs
include
queryarray string[]
Specify related data to side load.
Possible valuesusersprojectstasks

Responses

200A list of daily activities
object
  • daily_activitiesarray
    array<object>
    items
    object

    DailyActivity model

    • idinteger required

      Daily activity ID

    • datestring required

      Organization date

    • user_idinteger required

      User ID

    • project_idinteger required

      Project ID

    • task_idinteger required

      Task ID

    • keyboardinteger required

      The amount of time (subset of tracked) the keyboard was active within the time worked in seconds

    • mouseinteger required

      The amount of time (subset of tracked) the mouse was active within the time worked in seconds

    • overallinteger required

      The amount of time (subset of tracked) the keyboard or mouse was active within the time worked in seconds

    • trackedinteger required

      Total time worked in seconds

    • input_trackedinteger required

      Total time worked in seconds (subset of tracked) with input tracking enabled (keyboard, mouse)

    • manualinteger required

      The amount of manual time in seconds (subset of tracked)

    • idleinteger required

      The amount of idle time in seconds (subset of tracked)

    • resumedinteger required

      The amount of resumed time in seconds (subset of tracked)

    • billableinteger required

      The amount of billable time in seconds (subset of tracked)

    • work_breakinteger required

      The amount of work break time in seconds (subset of tracked)

    • created_atstring required

      When the record was created

    • updated_atstring required

      When the record was last updated

Example response
json
{
  "daily_activities": [
    {
      "id": 0,
      "date": "2024-01-15",
      "user_id": 0,
      "project_id": 0,
      "task_id": 0,
      "keyboard": 0,
      "mouse": 0,
      "overall": 0,
      "tracked": 0,
      "input_tracked": 0,
      "manual": 0,
      "idle": 0,
      "resumed": 0,
      "billable": 0,
      "work_break": 0,
      "created_at": "2024-01-15T10:30:00Z",
      "updated_at": "2024-01-15T10:30:00Z"
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}

List organization daily activities updates

GET/v2/organizations/{organization_id}/activities/daily/updates

Returns daily activities that were modified within the specified time range. Useful for syncing changes.

Use updated[start] and updated[stop] to specify the modification time range. Results can also be filtered by user_ids[], task_ids[], and project_ids[].

Note: Updated time range limit is 31 days. Only returns activities from the last month.

Parameters

NameInTypeDescription
organization_idrequired
pathinteger (int32)
updated[start]required
querystring (date-time)
Start time (ISO 8601)
updated[stop]
querystring (date-time)
Stop time (ISO 8601, Exclusive)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
user_ids
queryarray integer[]
List of user IDs
task_ids
queryarray integer[]
List of task IDs
project_ids
queryarray integer[]
List of project IDs
include
queryarray string[]
Specify related data to side load.
Possible valuesusersprojectstasks

Responses

200A list of daily activities
object
  • daily_activitiesarray
    array<object>
    items
    object

    DailyActivity model

    • idinteger required

      Daily activity ID

    • datestring required

      Organization date

    • user_idinteger required

      User ID

    • project_idinteger required

      Project ID

    • task_idinteger required

      Task ID

    • keyboardinteger required

      The amount of time (subset of tracked) the keyboard was active within the time worked in seconds

    • mouseinteger required

      The amount of time (subset of tracked) the mouse was active within the time worked in seconds

    • overallinteger required

      The amount of time (subset of tracked) the keyboard or mouse was active within the time worked in seconds

    • trackedinteger required

      Total time worked in seconds

    • input_trackedinteger required

      Total time worked in seconds (subset of tracked) with input tracking enabled (keyboard, mouse)

    • manualinteger required

      The amount of manual time in seconds (subset of tracked)

    • idleinteger required

      The amount of idle time in seconds (subset of tracked)

    • resumedinteger required

      The amount of resumed time in seconds (subset of tracked)

    • billableinteger required

      The amount of billable time in seconds (subset of tracked)

    • work_breakinteger required

      The amount of work break time in seconds (subset of tracked)

    • created_atstring required

      When the record was created

    • updated_atstring required

      When the record was last updated

Example response
json
{
  "daily_activities": [
    {
      "id": 0,
      "date": "2024-01-15",
      "user_id": 0,
      "project_id": 0,
      "task_id": 0,
      "keyboard": 0,
      "mouse": 0,
      "overall": 0,
      "tracked": 0,
      "input_tracked": 0,
      "manual": 0,
      "idle": 0,
      "resumed": 0,
      "billable": 0,
      "work_break": 0,
      "created_at": "2024-01-15T10:30:00Z",
      "updated_at": "2024-01-15T10:30:00Z"
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}

List organization last activities

GET/v2/organizations/{organization_id}/last_activities

Returns the most recent activity for each member in the organization.

Parameters

NameInTypeDescription
organization_idrequired
pathinteger (int32)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
include_removed
queryboolean
Include users that were removed
include
queryarray string[]
Specify related data to side load.
Possible valuesusersprojectstasks

Responses

200Last activities for members
object
  • last_activitiesarray
    array<object>
    items
    object

    LastActivity model

    • last_client_activitystring required

      Last client activity of user

    • onlineboolean required

      Whether we consider the user online or not

    • last_project_idinteger

      Last project ID the user worked on

    • last_task_idinteger required

      Last task ID the user worked on

    • user_idinteger required

      User ID

Example response
json
{
  "last_activities": [
    {
      "last_client_activity": "2024-01-15T10:30:00Z",
      "online": false,
      "last_project_id": 0,
      "last_task_id": 0,
      "user_id": 0
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}

List project activities

GET/v2/projects/{project_id}/activities

Returns a collection of activities (10-minute time blocks) for the given project.

Results can be filtered by user, task, project, and time range (time_slot[start], time_slot[stop]).

For aggregated daily data, use the daily_activities endpoint instead.

Note: Data may be delayed up to 20 minutes. Note: Date range limit is 7 days. Earliest date is 6 months ago.

Parameters

NameInTypeDescription
project_idrequired
pathinteger (int32)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
time_slot[start]required
querystring (date-time)
Start time (ISO 8601)
time_slot[stop]required
querystring (date-time)
Stop time (ISO 8601, Exclusive)
user_ids
queryarray integer[]
List of user IDs
task_ids
queryarray integer[]
List of task IDs
global_todo_ids
queryarray integer[]
List of global todo IDs
include
queryarray string[]
Specify related data to side load.
Possible valuesuserstasks
time_zone
querystring
The time zone name for the activity

Responses

200A list of activities
object
  • activitiesarray
    array<object>
    items
    object

    Activity model

    • idinteger required

      Activity ID

    • datestring required

      Organization date

    • created_atstring required

      When the record was created

    • updated_atstring required

      When the record was last updated

    • time_slotstring required

      Time slot

    • starts_atstring required

      Date and time tracking was started within time slot

    • user_idinteger required

      User ID

    • project_idinteger required

      Project ID

    • task_idinteger required

      Task ID

    • keyboardinteger required

      The amount of time the keyboard was active within the time worked in seconds

    • mouseinteger required

      The amount of time the mouse was active within the time worked in seconds

    • overallinteger required

      The amount of time the keyboard or mouse was active within the time worked in seconds

    • trackedinteger required

      Total time worked in seconds

    • input_trackedinteger required

      Total time worked in seconds with input tracking enabled (keyboard, mouse)

    • tracks_inputboolean required

      Whether the source can and had input tracking enabled activities (keyboard, mouse)

    • location_typestring required

      Remote vs in-office status: unknown, remote, or on_site

    • billableboolean required

      Whether the time is billable

    • paidboolean required

      Whether the time has been marked paid

    • client_invoicedboolean required

      Whether the time has been invoiced to a client

    • team_invoicedboolean required

      Whether the time has been invoiced for a team member

    • immutableboolean required

      Whether the time is locked

    • timesheet_idinteger

      The timesheet for this activity

    • timesheet_lockedboolean

      Whether the timesheet is locking this activity

    • time_typestring required

      The type of activity this is

    • clientstring required

      Which client the activity originated from

Example response
json
{
  "activities": [
    {
      "id": 0,
      "date": "2024-01-15",
      "created_at": "2024-01-15T10:30:00Z",
      "updated_at": "2024-01-15T10:30:00Z",
      "time_slot": "2024-01-15T10:30:00Z",
      "starts_at": "2024-01-15T10:30:00Z",
      "user_id": 0,
      "project_id": 0,
      "task_id": 0,
      "keyboard": 0,
      "mouse": 0,
      "overall": 0,
      "tracked": 0,
      "input_tracked": 0,
      "tracks_input": false,
      "location_type": "string",
      "billable": false,
      "paid": false,
      "client_invoiced": false,
      "team_invoiced": false,
      "immutable": false,
      "timesheet_id": 0,
      "timesheet_locked": false,
      "time_type": "string",
      "client": "string"
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}

List project activities updates

GET/v2/projects/{project_id}/activities/updates

Returns activities that were updated within the given time range. Useful for syncing changes.

Results can be filtered by updated[start]/[stop], user_ids[], task_ids[], global_todo_ids[], and project_ids[].

Note: Data may be delayed up to 20 minutes. Date range limit is 7 days. Earliest date is 45 days ago.

Parameters

NameInTypeDescription
project_idrequired
pathinteger (int32)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
updated[start]required
querystring (date-time)
Start time (ISO 8601)
updated[stop]required
querystring (date-time)
Stop time (ISO 8601)
user_ids
queryarray integer[]
List of user IDs
task_ids
queryarray integer[]
List of task IDs
global_todo_ids
queryarray integer[]
List of global todo IDs
include
queryarray string[]
Specify related data to side load.
Possible valuesuserstasks

Responses

200A list of activities
object
  • activitiesarray
    array<object>
    items
    object

    Activity model

    • idinteger required

      Activity ID

    • datestring required

      Organization date

    • created_atstring required

      When the record was created

    • updated_atstring required

      When the record was last updated

    • time_slotstring required

      Time slot

    • starts_atstring required

      Date and time tracking was started within time slot

    • user_idinteger required

      User ID

    • project_idinteger required

      Project ID

    • task_idinteger required

      Task ID

    • keyboardinteger required

      The amount of time the keyboard was active within the time worked in seconds

    • mouseinteger required

      The amount of time the mouse was active within the time worked in seconds

    • overallinteger required

      The amount of time the keyboard or mouse was active within the time worked in seconds

    • trackedinteger required

      Total time worked in seconds

    • input_trackedinteger required

      Total time worked in seconds with input tracking enabled (keyboard, mouse)

    • tracks_inputboolean required

      Whether the source can and had input tracking enabled activities (keyboard, mouse)

    • location_typestring required

      Remote vs in-office status: unknown, remote, or on_site

    • billableboolean required

      Whether the time is billable

    • paidboolean required

      Whether the time has been marked paid

    • client_invoicedboolean required

      Whether the time has been invoiced to a client

    • team_invoicedboolean required

      Whether the time has been invoiced for a team member

    • immutableboolean required

      Whether the time is locked

    • timesheet_idinteger

      The timesheet for this activity

    • timesheet_lockedboolean

      Whether the timesheet is locking this activity

    • time_typestring required

      The type of activity this is

    • clientstring required

      Which client the activity originated from

Example response
json
{
  "activities": [
    {
      "id": 0,
      "date": "2024-01-15",
      "created_at": "2024-01-15T10:30:00Z",
      "updated_at": "2024-01-15T10:30:00Z",
      "time_slot": "2024-01-15T10:30:00Z",
      "starts_at": "2024-01-15T10:30:00Z",
      "user_id": 0,
      "project_id": 0,
      "task_id": 0,
      "keyboard": 0,
      "mouse": 0,
      "overall": 0,
      "tracked": 0,
      "input_tracked": 0,
      "tracks_input": false,
      "location_type": "string",
      "billable": false,
      "paid": false,
      "client_invoiced": false,
      "team_invoiced": false,
      "immutable": false,
      "timesheet_id": 0,
      "timesheet_locked": false,
      "time_type": "string",
      "client": "string"
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}

List project daily activities

GET/v2/projects/{project_id}/activities/daily

Returns daily aggregated time tracking data for the given project.

Results can be filtered by user_ids[], task_ids[], project_ids[], and date[start]/[stop]. Data is aggregated by organization timezone date.

Note: Date range limit is 31 days. Earliest date is 3 years ago.

Parameters

NameInTypeDescription
project_idrequired
pathinteger (int32)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
date[start]required
querystring (date)
Start date (ISO 8601)
date[stop]required
querystring (date)
Stop date (ISO 8601, Inclusive)
user_ids
queryarray integer[]
List of user IDs
task_ids
queryarray integer[]
List of task IDs
include
queryarray string[]
Specify related data to side load.
Possible valuesuserstasks

Responses

200A list of daily activities
object
  • daily_activitiesarray
    array<object>
    items
    object

    DailyActivity model

    • idinteger required

      Daily activity ID

    • datestring required

      Organization date

    • user_idinteger required

      User ID

    • project_idinteger required

      Project ID

    • task_idinteger required

      Task ID

    • keyboardinteger required

      The amount of time (subset of tracked) the keyboard was active within the time worked in seconds

    • mouseinteger required

      The amount of time (subset of tracked) the mouse was active within the time worked in seconds

    • overallinteger required

      The amount of time (subset of tracked) the keyboard or mouse was active within the time worked in seconds

    • trackedinteger required

      Total time worked in seconds

    • input_trackedinteger required

      Total time worked in seconds (subset of tracked) with input tracking enabled (keyboard, mouse)

    • manualinteger required

      The amount of manual time in seconds (subset of tracked)

    • idleinteger required

      The amount of idle time in seconds (subset of tracked)

    • resumedinteger required

      The amount of resumed time in seconds (subset of tracked)

    • billableinteger required

      The amount of billable time in seconds (subset of tracked)

    • work_breakinteger required

      The amount of work break time in seconds (subset of tracked)

    • created_atstring required

      When the record was created

    • updated_atstring required

      When the record was last updated

Example response
json
{
  "daily_activities": [
    {
      "id": 0,
      "date": "2024-01-15",
      "user_id": 0,
      "project_id": 0,
      "task_id": 0,
      "keyboard": 0,
      "mouse": 0,
      "overall": 0,
      "tracked": 0,
      "input_tracked": 0,
      "manual": 0,
      "idle": 0,
      "resumed": 0,
      "billable": 0,
      "work_break": 0,
      "created_at": "2024-01-15T10:30:00Z",
      "updated_at": "2024-01-15T10:30:00Z"
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}

List project daily activities updates

GET/v2/projects/{project_id}/activities/daily/updates

Returns daily activities that were modified within the specified time range. Useful for syncing changes.

Use updated[start] and updated[stop] to specify the modification time range. Results can also be filtered by user_ids[], task_ids[], and project_ids[].

Note: Updated time range limit is 31 days. Only returns activities from the last month.

Parameters

NameInTypeDescription
project_idrequired
pathinteger (int32)
updated[start]required
querystring (date-time)
Start time (ISO 8601)
updated[stop]
querystring (date-time)
Stop time (ISO 8601, Exclusive)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
user_ids
queryarray integer[]
List of user IDs
task_ids
queryarray integer[]
List of task IDs
include
queryarray string[]
Specify related data to side load.
Possible valuesuserstasks

Responses

200A list of daily activities
object
  • daily_activitiesarray
    array<object>
    items
    object

    DailyActivity model

    • idinteger required

      Daily activity ID

    • datestring required

      Organization date

    • user_idinteger required

      User ID

    • project_idinteger required

      Project ID

    • task_idinteger required

      Task ID

    • keyboardinteger required

      The amount of time (subset of tracked) the keyboard was active within the time worked in seconds

    • mouseinteger required

      The amount of time (subset of tracked) the mouse was active within the time worked in seconds

    • overallinteger required

      The amount of time (subset of tracked) the keyboard or mouse was active within the time worked in seconds

    • trackedinteger required

      Total time worked in seconds

    • input_trackedinteger required

      Total time worked in seconds (subset of tracked) with input tracking enabled (keyboard, mouse)

    • manualinteger required

      The amount of manual time in seconds (subset of tracked)

    • idleinteger required

      The amount of idle time in seconds (subset of tracked)

    • resumedinteger required

      The amount of resumed time in seconds (subset of tracked)

    • billableinteger required

      The amount of billable time in seconds (subset of tracked)

    • work_breakinteger required

      The amount of work break time in seconds (subset of tracked)

    • created_atstring required

      When the record was created

    • updated_atstring required

      When the record was last updated

Example response
json
{
  "daily_activities": [
    {
      "id": 0,
      "date": "2024-01-15",
      "user_id": 0,
      "project_id": 0,
      "task_id": 0,
      "keyboard": 0,
      "mouse": 0,
      "overall": 0,
      "tracked": 0,
      "input_tracked": 0,
      "manual": 0,
      "idle": 0,
      "resumed": 0,
      "billable": 0,
      "work_break": 0,
      "created_at": "2024-01-15T10:30:00Z",
      "updated_at": "2024-01-15T10:30:00Z"
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}

List project last activities

GET/v2/projects/{project_id}/last_activities

Returns the most recent activity for each member in the project.

Parameters

NameInTypeDescription
project_idrequired
pathinteger (int32)
page_start_id
queryinteger (int32)
The page start ID.
page_limit
queryinteger (int32)
The default page size
include_removed
queryboolean
Include users that were removed
include
queryarray string[]
Specify related data to side load.
Possible valuesuserstasks

Responses

200Last activities for members
object
  • last_activitiesarray
    array<object>
    items
    object

    LastActivity model

    • last_client_activitystring required

      Last client activity of user

    • onlineboolean required

      Whether we consider the user online or not

    • last_project_idinteger

      Last project ID the user worked on

    • last_task_idinteger required

      Last task ID the user worked on

    • user_idinteger required

      User ID

Example response
json
{
  "last_activities": [
    {
      "last_client_activity": "2024-01-15T10:30:00Z",
      "online": false,
      "last_project_id": 0,
      "last_task_id": 0,
      "user_id": 0
    }
  ]
}
400Invalid parameters
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
401Unauthorized
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
403API access is only for organizations on an active plan
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
404Could not find record
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}
429Rate limit exceeded
object

Hubstaff_Public_V2_Entities_Error model

  • codestring required

    Legacy string error code for backward compatibility

  • error_codeinteger

    Numeric error code for i18n/programmatic handling. Ranges: 10000-10999 (Auth), 11000-11999 (Validation), 12000-12999 (Resource), 13000-13999 (Rate Limit), 14000-14999 (Time Entry/Activity), 15000-15999 (System). See GET /v2/error_codes for full reference.

  • errorstring required

    Human-readable error message

  • detailsarray

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    array<string>

    Per-attribute validation errors: [{attribute, error}]. Present on validation failures.

    items
    string
Example response
json
{
  "code": "string",
  "error_code": 0,
  "error": "string",
  "details": [
    "string"
  ]
}